;*************************************************************************
;				Constant definitions
;-------------------------------------------------------------------------
.equ	VERSION		= 0x0103

.equ	XTAL		= 8000000	;8MHZ

#ifdef BootStart1
#define BootStart	BootStart1
#define UserFlash	(2*BootStart)
#define USE_SPH
#else
#define	BootSize	205		;410 Byte
#define BootStart	((FlashEnd - BootSize) / PageSize * PageSize)
#define	UserFlash	(2*BootStart - 2)
#endif

.equ	COMMAND		= 0xA5		;Command sequence start
.equ	CONTINUE	= 'z'
.equ	SUCCESS		= 'y'
.equ	FAIL		= 'x'
.equ	ANSWER		= 0xA6
;-------------------------------------------------------------------------
;				Using register
;-------------------------------------------------------------------------
.def	zerol		= r2
.def	zeroh		= r3
.def	rjmpappl	= r4		;application start address
.def	rjmpapph	= r5
.def	baudl		= r6		;baud divider
.def	baudh		= r7
.def	tmpl		= r8
.def	tmph		= r9
;-------------------------------------------------------------------------
.def	a0		= r16		;working registers
.def	a1		= r17
.def	a2		= r18
.def	a3		= r19

.def	flags		= r22
.equ	FError		= 0
.def	twx		= r23		;wait time byte 3
.def	twl		= r24		;wait time
.def	twh		= r25
;-------------------------------------------------------------------------
;				Using SRAM
;-------------------------------------------------------------------------
.dseg
#ifndef BufferSize
#define BufferSize PageSize
#endif
	.org		SRAM_START
PROGBUFF:		.byte 2*BufferSize
PROGBUFFEND:
.cseg
;-------------------------------------------------------------------------
;				Macros
;-------------------------------------------------------------------------
.macro	TXD_0
	cbi	STX_PORT, STX
.endmacro
.macro	TXD_1
	sbi	STX_PORT, STX
.endmacro
.macro	SKIP_RXD_0
	sbic	SRX_PIN, SRX
.endmacro
.macro	SKIP_RXD_1
	sbis	SRX_PIN, SRX
.endmacro
;-------------------------------------------------------------------------
